package controllers;

import model.Contact;
import model.ContactManager;
import model.ContactManagerImpl;
import play.data.DynamicForm;
import play.data.Form;
import play.libs.Json;
import play.mvc.*;

import views.html.*;

public class Application extends Controller {

    private final static ContactManager cm = new ContactManagerImpl();

    /*
    Default
     */
    public static Result index() {




        return ok(index.render());
    }

    public static Result loadContact(final Long id) {

        final Contact c = cm.loadContact(id);

        if (c != null) {
            return ok(Json.toJson(c));
        }
        return notFound("No contact found");
    }

    public static Result all() {
        return ok(Json.toJson(cm.loadAllContacts()));
    }

    public static Result deleteContact(final Long id) {
        cm.deleteContact(id);
        return ok("Contact has been deleted!");
    }

    public static Result saveContact() {
        final DynamicForm rdata = Form.form().bindFromRequest();
        final String firstName = rdata.get("firstName");
        final String lastName = rdata.get("lastName");
        final String adresse = rdata.get("adresse");
        final String phone = rdata.get("numTel");
        final Contact newContact = new Contact(firstName, lastName, adresse, phone);
        cm.saveContact(newContact);
        return ok("Contact saved!");
    }

    public static Result findByName(final String name) {
        return ok(Json.toJson(cm.findContactByName(name)));
    }

    public static Result findByPhone(final String phone) {
        return ok(Json.toJson(cm.findContactByPhoneNumber(phone)));
    }


}
