package model;

import com.google.common.base.Predicate;
import com.google.common.collect.Collections2;
import com.google.common.collect.Sets;

import javax.annotation.Nullable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by fsznajderman on 09/01/2014.
 */
public class ContactManagerImpl implements ContactManager {

    final Map<Long, Contact> bd = new HashMap();


    public ContactManagerImpl() {
        bd.put(42L, new Contact("Fabrice", "Sznajderman", "6 rue des maisons", "0102030405"));
        bd.put(53L, new Contact("Géraldine", "Dupond", "4 rue des fleurs", "0503020104"));
        bd.put(12L, new Contact("Francois", "Duprin", "Batiment 5 résidence chambrey", ""));
        bd.put(70L, new Contact("Loic", "Martin", "Dijon centre", "1002304030"));

    }

    @Override
    public Contact loadContact(Long id) {
        return bd.get(id);
    }

    @Override
    public Collection<Contact> loadAllContacts() {
        return bd.values();
    }

    @Override
    public void saveContact(Contact contact) {
        final Collection<Long> c = Sets.newTreeSet(bd.keySet()).descendingSet();
        final Long id = (c.iterator().next()) + 1;
        System.out.println(id);
        bd.put(id, contact);
    }

    @Override
    public void deleteContact(Long id) {

        bd.remove(id);
    }

    @Override
    public void updateContact(final Long id, Contact contact) {
        bd.put(id, contact);

    }

    @Override
    public Collection<Contact> findContactByName(final String name) {

        return Collections2.filter(bd.values(), new Predicate<Contact>() {
            @Override
            public boolean apply(@Nullable Contact contact) {


                return name.equalsIgnoreCase(contact.getFirstName());
            }
        });

    }

    @Override
    public Collection<Contact> findContactByPhoneNumber(final String phoneNumber) {
        return Collections2.filter(bd.values(), new Predicate<Contact>() {
            @Override
            public boolean apply(@Nullable Contact contact) {
                return phoneNumber.equalsIgnoreCase(contact.getNumTel());
            }
        });
    }


}
